using System;
using System.Drawing;
using System.Windows.Forms;


namespace MyNamespace
{
	/// <summary>
	/// PlotForm is the Windows Form Component for testing the plotting functions in C#
	/// Developed by Michael Gold in 2002 and modified by Harry J. Smith in 2005
	/// See C# Corner at: http://www.c-sharpcorner.com/Code/2002/Aug/XYPlotControl.asp
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>
	public class PlotForm : Form
	{
		private Button buttonAbout;
		private Button buttonExit;
		private Button buttonFirstF;
		private Button buttonFm;
		private Button buttonFp;
		private Button buttonMm;
		private Button buttonMp;
		private Button buttonNm;
		private Button buttonNp;
		private Button buttonNumberN;
		private Button buttonPlot;
		private Button buttonSkipM;
		private Label labelFirstF;
		private Label labelMaxP;
		private Label labelNumberN;
		private Label labelSkipM;
		private PlotControl PlotControlXY;
		private static float dPR = 180f / pi;
		private static float pi = 4.0f * (float)Math.Atan(1.0);
		private static float pi2 = 2.0f * pi;
		private System.ComponentModel.IContainer components;
		private TextBox textBoxFirstF;
		private TextBox textBoxNumberN;
		private TextBox textBoxSkipM;
		private Timer timerPlot;
		public static Screen screen;

		public PlotForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.Text = Global.title + " - Plot";
			textBoxNumberN.Text = n.ToString();
			buttonNumberN_Click();
			textBoxFirstF.Text = f.ToString();
			buttonFirstF_Click();
			textBoxSkipM.Text = m.ToString();
			buttonSkipM_Click();
			DisplayMaxP();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PlotForm));
			this.labelNumberN = new Label();
			this.buttonNumberN = new Button();
			this.textBoxNumberN = new TextBox();
			this.labelFirstF = new Label();
			this.buttonFirstF = new Button();
			this.textBoxFirstF = new TextBox();
			this.buttonSkipM = new Button();
			this.textBoxSkipM = new TextBox();
			this.buttonExit = new Button();
			this.buttonAbout = new Button();
			this.buttonPlot = new Button();
			this.labelSkipM = new Label();
			this.timerPlot = new Timer(this.components);
			this.buttonNm = new Button();
			this.buttonNp = new Button();
			this.buttonFm = new Button();
			this.buttonFp = new Button();
			this.buttonMm = new Button();
			this.buttonMp = new Button();
			this.PlotControlXY = new MyNamespace.PlotControl();
			this.labelMaxP = new Label();
			this.SuspendLayout();
			// 
			// labelNumberN
			// 
			this.labelNumberN.Location = new System.Drawing.Point(141, 634);
			this.labelNumberN.Name = "labelNumberN";
			this.labelNumberN.Size = new System.Drawing.Size(94, 32);
			this.labelNumberN.TabIndex = 2;
			this.labelNumberN.Text = "Number n = 1000";
			// 
			// buttonNumberN
			// 
			this.buttonNumberN.BackColor = System.Drawing.SystemColors.Control;
			this.buttonNumberN.Location = new System.Drawing.Point(288, 632);
			this.buttonNumberN.Name = "buttonNumberN";
			this.buttonNumberN.Size = new System.Drawing.Size(75, 23);
			this.buttonNumberN.TabIndex = 4;
			this.buttonNumberN.Text = "Change It";
			this.buttonNumberN.UseVisualStyleBackColor = false;
			this.buttonNumberN.Click += new System.EventHandler(this.buttonNumberN_Click);
			this.buttonNumberN.KeyDown += new KeyEventHandler(this.buttonNumberN_KeyDown);
			// 
			// textBoxNumberN
			// 
			this.textBoxNumberN.Location = new System.Drawing.Point(232, 632);
			this.textBoxNumberN.Name = "textBoxNumberN";
			this.textBoxNumberN.Size = new System.Drawing.Size(50, 20);
			this.textBoxNumberN.TabIndex = 3;
			this.textBoxNumberN.Text = "0";
			this.textBoxNumberN.TextChanged += new System.EventHandler(this.textBoxNumberN_TextChanged);
			this.textBoxNumberN.KeyDown += new KeyEventHandler(this.textBoxNumberN_KeyDown);
			// 
			// labelFirstF
			// 
			this.labelFirstF.Location = new System.Drawing.Point(398, 634);
			this.labelFirstF.Name = "labelFirstF";
			this.labelFirstF.Size = new System.Drawing.Size(77, 32);
			this.labelFirstF.TabIndex = 5;
			this.labelFirstF.Text = "First f = 1000";
			// 
			// buttonFirstF
			// 
			this.buttonFirstF.BackColor = System.Drawing.SystemColors.Control;
			this.buttonFirstF.Location = new System.Drawing.Point(528, 632);
			this.buttonFirstF.Name = "buttonFirstF";
			this.buttonFirstF.Size = new System.Drawing.Size(75, 23);
			this.buttonFirstF.TabIndex = 7;
			this.buttonFirstF.Text = "Change It";
			this.buttonFirstF.UseVisualStyleBackColor = false;
			this.buttonFirstF.Click += new System.EventHandler(this.buttonFirstF_Click);
			this.buttonFirstF.KeyDown += new KeyEventHandler(this.buttonFirstF_KeyDown);
			// 
			// textBoxFirstF
			// 
			this.textBoxFirstF.Location = new System.Drawing.Point(472, 632);
			this.textBoxFirstF.Name = "textBoxFirstF";
			this.textBoxFirstF.Size = new System.Drawing.Size(50, 20);
			this.textBoxFirstF.TabIndex = 6;
			this.textBoxFirstF.Text = "0";
			this.textBoxFirstF.TextChanged += new System.EventHandler(this.textBoxFirstF_TextChanged);
			this.textBoxFirstF.KeyDown += new KeyEventHandler(this.textBoxFirstF_KeyDown);
			// 
			// buttonSkipM
			// 
			this.buttonSkipM.BackColor = System.Drawing.SystemColors.Control;
			this.buttonSkipM.Location = new System.Drawing.Point(770, 632);
			this.buttonSkipM.Name = "buttonSkipM";
			this.buttonSkipM.Size = new System.Drawing.Size(75, 23);
			this.buttonSkipM.TabIndex = 15;
			this.buttonSkipM.Text = "Change It";
			this.buttonSkipM.UseVisualStyleBackColor = false;
			this.buttonSkipM.Click += new System.EventHandler(this.buttonSkipM_Click);
			this.buttonSkipM.KeyDown += new KeyEventHandler(this.buttonSkipM_KeyDown);
			// 
			// textBoxSkipM
			// 
			this.textBoxSkipM.Location = new System.Drawing.Point(717, 632);
			this.textBoxSkipM.Name = "textBoxSkipM";
			this.textBoxSkipM.Size = new System.Drawing.Size(47, 20);
			this.textBoxSkipM.TabIndex = 14;
			this.textBoxSkipM.Text = "0";
			this.textBoxSkipM.TextChanged += new System.EventHandler(this.textBoxSkipM_TextChanged);
			this.textBoxSkipM.KeyDown += new KeyEventHandler(this.textBoxSkipM_KeyDown);
			// 
			// buttonExit
			// 
			this.buttonExit.BackColor = System.Drawing.SystemColors.Control;
			this.buttonExit.Location = new System.Drawing.Point(918, 658);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(48, 24);
			this.buttonExit.TabIndex = 11;
			this.buttonExit.Text = "Exit";
			this.buttonExit.UseVisualStyleBackColor = false;
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new KeyEventHandler(this.buttonExit_KeyDown);
			// 
			// buttonAbout
			// 
			this.buttonAbout.BackColor = System.Drawing.SystemColors.Control;
			this.buttonAbout.Location = new System.Drawing.Point(864, 658);
			this.buttonAbout.Name = "buttonAbout";
			this.buttonAbout.Size = new System.Drawing.Size(48, 24);
			this.buttonAbout.TabIndex = 10;
			this.buttonAbout.Text = "About";
			this.buttonAbout.UseVisualStyleBackColor = false;
			this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
			this.buttonAbout.KeyDown += new KeyEventHandler(this.buttonAbout_KeyDown);
			// 
			// buttonPlot
			// 
			this.buttonPlot.BackColor = System.Drawing.SystemColors.Control;
			this.buttonPlot.Location = new System.Drawing.Point(864, 632);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.Size = new System.Drawing.Size(96, 24);
			this.buttonPlot.TabIndex = 12;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.UseVisualStyleBackColor = false;
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			this.buttonPlot.KeyDown += new KeyEventHandler(this.buttonPlot_KeyDown);
			// 
			// labelSkipM
			// 
			this.labelSkipM.Location = new System.Drawing.Point(638, 634);
			this.labelSkipM.Name = "labelSkipM";
			this.labelSkipM.Size = new System.Drawing.Size(82, 32);
			this.labelSkipM.TabIndex = 13;
			this.labelSkipM.Text = "Skip m = 1000";
			// 
			// timerPlot
			// 
			this.timerPlot.Enabled = true;
			this.timerPlot.Interval = 500;
			this.timerPlot.Tick += new System.EventHandler(this.timerPlot_Tick);
			// 
			// buttonNm
			// 
			this.buttonNm.BackColor = System.Drawing.SystemColors.Control;
			this.buttonNm.Location = new System.Drawing.Point(288, 658);
			this.buttonNm.Name = "buttonNm";
			this.buttonNm.Size = new System.Drawing.Size(33, 24);
			this.buttonNm.TabIndex = 23;
			this.buttonNm.Text = "-1";
			this.buttonNm.UseVisualStyleBackColor = false;
			this.buttonNm.Click += new System.EventHandler(this.buttonNm_Click);
			// 
			// buttonNp
			// 
			this.buttonNp.BackColor = System.Drawing.SystemColors.Control;
			this.buttonNp.Location = new System.Drawing.Point(330, 658);
			this.buttonNp.Name = "buttonNp";
			this.buttonNp.Size = new System.Drawing.Size(33, 24);
			this.buttonNp.TabIndex = 24;
			this.buttonNp.Text = "+1";
			this.buttonNp.UseVisualStyleBackColor = false;
			this.buttonNp.Click += new System.EventHandler(this.buttonNp_Click);
			// 
			// buttonFm
			// 
			this.buttonFm.BackColor = System.Drawing.SystemColors.Control;
			this.buttonFm.Location = new System.Drawing.Point(528, 658);
			this.buttonFm.Name = "buttonFm";
			this.buttonFm.Size = new System.Drawing.Size(33, 24);
			this.buttonFm.TabIndex = 25;
			this.buttonFm.Text = "-1";
			this.buttonFm.UseVisualStyleBackColor = false;
			this.buttonFm.Click += new System.EventHandler(this.buttonFm_Click);
			// 
			// buttonFp
			// 
			this.buttonFp.BackColor = System.Drawing.SystemColors.Control;
			this.buttonFp.Location = new System.Drawing.Point(570, 658);
			this.buttonFp.Name = "buttonFp";
			this.buttonFp.Size = new System.Drawing.Size(33, 24);
			this.buttonFp.TabIndex = 26;
			this.buttonFp.Text = "+1";
			this.buttonFp.UseVisualStyleBackColor = false;
			this.buttonFp.Click += new System.EventHandler(this.buttonFp_Click);
			// 
			// buttonMm
			// 
			this.buttonMm.BackColor = System.Drawing.SystemColors.Control;
			this.buttonMm.Location = new System.Drawing.Point(770, 658);
			this.buttonMm.Name = "buttonMm";
			this.buttonMm.Size = new System.Drawing.Size(33, 24);
			this.buttonMm.TabIndex = 27;
			this.buttonMm.Text = "-1";
			this.buttonMm.UseVisualStyleBackColor = false;
			this.buttonMm.Click += new System.EventHandler(this.buttonMm_Click);
			// 
			// buttonMp
			// 
			this.buttonMp.BackColor = System.Drawing.SystemColors.Control;
			this.buttonMp.Location = new System.Drawing.Point(812, 658);
			this.buttonMp.Name = "buttonMp";
			this.buttonMp.Size = new System.Drawing.Size(33, 24);
			this.buttonMp.TabIndex = 28;
			this.buttonMp.Text = "+1";
			this.buttonMp.UseVisualStyleBackColor = false;
			this.buttonMp.Click += new System.EventHandler(this.buttonMp_Click);
			// 
			// PlotControlXY
			// 
			this.PlotControlXY.AbsolutePoint = new System.Drawing.Point(-2147483583, -2147483089);
			this.PlotControlXY.BackColor = System.Drawing.SystemColors.Window;
			this.PlotControlXY.ConnectPointsFlag = false;
			this.PlotControlXY.CurrentIndex = 0;
			this.PlotControlXY.LabelX = "";
			this.PlotControlXY.LabelY = "";
			this.PlotControlXY.LineColor = System.Drawing.Color.Blue;
			this.PlotControlXY.Location = new System.Drawing.Point(-24, 16);
			this.PlotControlXY.Name = "PlotControlXY";
			this.PlotControlXY.NumberOfPoints = 0;
			this.PlotControlXY.Size = new System.Drawing.Size(992, 600);
			this.PlotControlXY.TabIndex = 22;
			this.PlotControlXY.XOrigin = 0F;
			this.PlotControlXY.XTickValue = 1F;
			this.PlotControlXY.XValue = -2.147484E+09F;
			this.PlotControlXY.YOrigin = 0F;
			this.PlotControlXY.YTickValue = 1F;
			this.PlotControlXY.YValue = -2.147484E+09F;
			this.PlotControlXY.KeyDown += new KeyEventHandler(this.PlotControlXY_KeyDown);
			// 
			// labelMaxP
			// 
			this.labelMaxP.Location = new System.Drawing.Point(12, 634);
			this.labelMaxP.Name = "labelMaxP";
			this.labelMaxP.Size = new System.Drawing.Size(102, 48);
			this.labelMaxP.TabIndex = 29;
			this.labelMaxP.Text = "Max Points Plotted = 1000";
			// 
			// PlotForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(992, 694);
			this.Controls.Add(this.labelMaxP);
			this.Controls.Add(this.buttonMp);
			this.Controls.Add(this.buttonMm);
			this.Controls.Add(this.buttonFp);
			this.Controls.Add(this.buttonFm);
			this.Controls.Add(this.buttonNp);
			this.Controls.Add(this.buttonNm);
			this.Controls.Add(this.textBoxSkipM);
			this.Controls.Add(this.textBoxFirstF);
			this.Controls.Add(this.textBoxNumberN);
			this.Controls.Add(this.labelSkipM);
			this.Controls.Add(this.buttonSkipM);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.buttonAbout);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.labelFirstF);
			this.Controls.Add(this.buttonFirstF);
			this.Controls.Add(this.labelNumberN);
			this.Controls.Add(this.buttonNumberN);
			this.Controls.Add(this.PlotControlXY);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlotForm";
			this.Text = "<App.Title> - Run";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.PlotForm_Closing);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		// -------- Begin Main program, Plot
		public void Plot() 
		{
			// don't allow Plot form to be brought up more than once
			if (Common.plotUp) { Dispose(true); return; }
			Common.plotUp = true;
			screen = Screen.PrimaryScreen;
			// gets the screen size but not used
			Size size = new System.Drawing.Size(screen.Bounds.Width, screen.Bounds.Height);
			buttonPlot_Click();
			buttonExit.Focus();	// a new plot form just came up
		}

		private void textBoxNumberN_TextChanged(object sender, System.EventArgs e)
		// process input of NumberN
		{
			textBoxNumberN.Text = textBoxNumberN.Text.TrimStart(' ');	// remove leading spaces
			textBoxNumberN.Text = textBoxNumberN.Text.TrimStart('0');	// remove leading zeros
			if (textBoxNumberN.Text == "")
			{
				buttonNumberN.Enabled = true;
				return;
			}
			string sNum = textBoxNumberN.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				buttonNumberN.Enabled = (1 <= iNum) && (iNum <= maxN);
			}
			else
			{
				buttonNumberN.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ')	// if space at right end of field
				{
					textBoxNumberN.Text = textBoxNumberN.Text.Trim(' ');			// remove trailing spaces
					textBoxNumberN.SelectionStart = textBoxNumberN.Text.Length;		// move to right end of input
					if (buttonNumberN.Enabled) buttonNumberN_Click();				// accept the input
				}
			}
		}

		private void textBoxNumberN_KeyDown(object sender, KeyEventArgs e)
		// process keys when in NumberN box
		{
			if (e.KeyCode == Keys.Return)	// return is an accept key here
			{
				// this sounds the bell
				if (buttonNumberN.Enabled) buttonNumberN_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Common.plotUp = false;
				Common.abortCalc = true;
				Dispose(true);
			}
		}

		private void buttonNumberN_Click(object sender, System.EventArgs e)
		{
			buttonNumberN_Click();
		}

		private void buttonNumberN_Click()
		{
			if (Common.running) return;
			if (textBoxNumberN.Text != "")					// if "", set to current
				n = Convert.ToInt32(textBoxNumberN.Text);
			textBoxNumberN.Text = n.ToString();
			DisplayNumberN();
			textBoxNumberN.Focus();
			textBoxNumberN.SelectionStart = textBoxNumberN.Text.Length;		
		}

		private void DisplayNumberN()	// display NumberN
		{
			labelNumberN.Text = "Number n = " + n;
		}

		private void textBoxSkipM_TextChanged(object sender, System.EventArgs e)
			// process input of SkipM
		{
			textBoxSkipM.Text = textBoxSkipM.Text.TrimStart(' ');			// remove leading spaces
			if (textBoxSkipM.Text == "")
			{
				buttonSkipM.Enabled = true;
				return;
			}
			string sNum = textBoxSkipM.Text;
			buttonSkipM.Enabled = Global.IsInt32(sNum);
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ')	// if space at right end of field
				{
					textBoxSkipM.Text = textBoxSkipM.Text.Trim(' ');			// remove trailing spaces
					textBoxSkipM.SelectionStart = textBoxSkipM.Text.Length;		// move to right end of input
					if (buttonSkipM.Enabled) buttonSkipM_Click();				// accept the input
				}
			}
		}

		private void textBoxSkipM_KeyDown(object sender, KeyEventArgs e)
		// process keys when in SkipM box
		{
			if (e.KeyCode == Keys.Return)	// return is an accept key here
			{
				// this sounds the bell
				if (buttonSkipM.Enabled) buttonSkipM_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Common.plotUp = false;
				Dispose(true);
			}
		}

		private void buttonSkipM_Click(object sender, System.EventArgs e)
		{
			buttonSkipM_Click();
		}

		private void buttonSkipM_Click()
		{
			if (Common.running) return;
			if (textBoxSkipM.Text != "")				// if "", set to current
				m = Convert.ToInt32(textBoxSkipM.Text);
			textBoxSkipM.Text = m.ToString();
			DisplaySkipM();
			textBoxSkipM.Focus();
			textBoxSkipM.SelectionStart = textBoxSkipM.Text.Length;
		}

		private void DisplaySkipM()	// display SkipM
		{
			labelSkipM.Text = "Skip m = " + m;
		}

		private void textBoxFirstF_TextChanged(object sender, System.EventArgs e)
		// process input of FirstF
		{
			textBoxFirstF.Text = textBoxFirstF.Text.TrimStart(' ');		// remove leading spaces
			textBoxFirstF.Text = textBoxFirstF.Text.TrimStart('0');		// remove leading zeros
			if (textBoxFirstF.Text == "")
			{
				buttonFirstF.Enabled = true;
				return;
			}
			string sNum = textBoxFirstF.Text;
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				buttonFirstF.Enabled = (1 <= iNum);
			}
			else
			{
				buttonFirstF.Enabled = false;
			}
			int n = sNum.Length;
			if (n > 0)
			{
				if (sNum[n-1] == ' ')	// if space at right end of field
				{
					textBoxFirstF.Text = textBoxFirstF.Text.Trim(' ');			// remove trailing spaces
					textBoxFirstF.SelectionStart = textBoxFirstF.Text.Length;	// move to right end of input
					if (buttonFirstF.Enabled) buttonFirstF_Click();				// accept the input
				}
			}
		}

		private void textBoxFirstF_KeyDown(object sender, KeyEventArgs e)
		// process keys when in FirstF box
		{
			if (e.KeyCode == Keys.Return)	// return is an accept key here
			{
				// this sounds the bell
				if (buttonFirstF.Enabled) buttonFirstF_Click();
			}
			if (e.KeyCode == Keys.Escape)
			{
				Common.plotUp = false;
				Dispose(true);
			}
		}

		private void buttonFirstF_Click(object sender, System.EventArgs e)
		{
			buttonFirstF_Click();
		}

		private void buttonFirstF_Click()
		{
			if (Common.running) return;
			if (textBoxFirstF.Text != "")			// if "", set to current
				f = Convert.ToInt32(textBoxFirstF.Text);
			textBoxFirstF.Text = f.ToString();
			DisplayFirstF();
			textBoxFirstF.Focus();
			textBoxFirstF.SelectionStart = textBoxFirstF.Text.Length;
		}

		private void DisplayFirstF()	// display FirstF
		{
			labelFirstF.Text = "First f = " + f;
		}

		private void DisplayMaxP()	// display MaxP
		{
			labelMaxP.Text = "Max Points Plotted = " + maxP;
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit Plot Form
		{
			Common.plotUp = false;
			Common.abortCalc = true;
			Dispose(true);
		}

		private void buttonAbout_Click(object sender, System.EventArgs e)
			// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void buttonPlot_Click(object sender, System.EventArgs e)
		{
			buttonPlot_Click();
		}

		private void buttonPlot_Click()
		{
			if (Common.running) return;
			StartupForm.objRunForm.SetRunning();
			PlotControlXY.Reset();
			PlotControlXY.NumberOfPens = 3;
			PlotControlXY.AddPen(0, Color.Green, 2f);
			PlotControlXY.XTickValue = 0.1f;
			PlotControlXY.YTickValue = 0.1f;
			PlotControlXY.XOrigin = -1.5f;
			PlotControlXY.YOrigin = -0.95f;
			PlotControlXY.LabelX = "";
			PlotControlXY.LabelY = "";
			for (float i = 0f; i < pi2; i += pi2 / 500f)
			{
				PlotControlXY.AddPoint((float)Math.Sin((double)i), (float)Math.Cos((double)i));
			}
			Common.abortCalc = false;
			Orbits();
			if (Common.abortCalc)
			{
				Common.abortCalc = false;
				StartupForm.objRunForm.SetNotRunning();
				return;
			}
			double de;
			de = pi2 / n;
			int nP = Math.Min(n, maxP);
			PlotControlXY.AddPen(1, Color.Red, 2f);
			for (i = 1; i <= nP; i++)
			{
				float x1 = (float)Math.Sin(de * i);
				float y1 = (float)Math.Cos(de * i);
				float x2 = (float)Math.Sin(de * a[i]);
				float y2 = (float)Math.Cos(de * a[i]);
				float dx = (x2 - x1);
				float dy = (y2 - y1);
				float h = 15 * (float)Math.Sqrt(dx * dx + dy * dy);
				if (h != 0)
				{
					dx = dx / h;
					dy = dy / h;
				}
				PlotControlXY.AddPoint(x1, y1);
				PlotControlXY.AddPoint(x2 + dx, y2 + dy);
				PlotControlXY.AddPoint(x1, y1);
			}
			PlotControlXY.AddPen(2, Color.Blue, 2f);
			for (i = 0; i <= nP; i++)
			{
				PlotControlXY.AddPoint((float)Math.Sin(de * i), (float)Math.Cos(de * i));
			}
			PlotControlXY.m_bConnectPoints = true;
 			PlotControlXY.Invalidate();
			StartupForm.objRunForm.SetNotRunning();
		} // buttonPlot_Click

		public static void Orbits()	// Determine the orbits
		// uses n, f, and m as input
		// computes a[], b[], and s
		{
			if (n == nP && f == fP && m == mP)
				return;
			nP = n;
			fP = f;
			mP = m;
			for (i = 1; i < n; i++)
				a[i] = i+1;					// Set position i to point to next position 
			a[n] = 1;
			p = 1 + ((f % n) + n - 2) % n;	// Init previous position based on f
			k = 1;  r = n;
			Common.statReq = false;
			Common.tV2 = Common.TimerF();
			do
			{
				if ((1 < k) && (k < n))		// If not first or last selection
				{
					for (i = 1; i <= (m - 1) % r; i++)	// Move m-1 positions (zero OK)
						p = a[p];
				}
				c = a[p];					// Update current position
				b[k] = c; c = a[c];			// Select the object at c
				a[a[p]] = k;				// Save execution order
				k++; r--;
				a[p] = c;					// Re-link circular chain of pointers
				Common.MuInterrupt();
				if (Common.abortCalc)
				{
					Common.WriteLn2("Manually aborted before Orbits finished");
					nP = 0;
					return;
				}
				if (Common.statReq)
					Common.WriteStatus("Orbits: " + (100.0 * k / n).ToString("0.00") + " Percent done");
			}
			while (k <= n);					// Until all are selected
			a[c] = n;						// a[c] was clobbered, so restore it
			s = 0;							// Count number of fixed elements
			for (i = 1; i <= n; i++)
				if (b[i] == i)
					s++;
		} // Orbits

		public static void ReportDetails()	// Generate detailed output
		// uses n, a[], and b[] as input
		{
			int tot = 0;
			Common.WriteLn("Execution order, when object i was selected:");
			for (i = 1; i <= n; i++)
			{
				Common.WriteT(a[i] + " ", ref tot);
				Common.MuInterrupt();
				if (Common.abortCalc)
				{
					Common.WriteLn();
					Common.WriteLn2("Manually aborted before report finished");
					return;
				}
			}
			Common.WriteLn();  Common.WriteLn();
			Common.WriteLn("Order of execution, object # selected on k'th selection:");
			tot = 0;
			for (i = 1; i <= n; i++)
			{
				Common.WriteT(b[i] + " ", ref tot);
				Common.MuInterrupt();
				if (Common.abortCalc)
				{
					Common.WriteLn();
					Common.WriteLn2("Manually aborted before report finished");
					return;
				}
			}
			Common.WriteLn();  Common.WriteLn();
			Common.WriteLn("The resulting permutation expressed in cyclic notation:");
			tot = 0;
			p = b[1];  c = 1;
			int[] t = new int[n + 1];	// temporary working array of objects
			for (i = 1; i <= n; i++) t[i] = a[i];
			do
			{
				Common.WriteT("(", ref tot);
				do
				{
					if (c != 0)
					{
						Common.WriteT("" + c, ref tot);
						t[p] = 0; p = c;
						Common.MuInterrupt();
						if (Common.abortCalc)
						{
							Common.WriteLn();
							Common.WriteLn2("Manually aborted before report finished");
							return;
						}
					}
					c = t[p];
					if (c != 0) Common.WriteT(", ", ref tot);
				} while (c != 0);
				Common.WriteT(")", ref tot);
				i = 0;
				do
				{
					i++;  c = t[i];
				}
				while ((c == 0) && (i != n));
				if (c != 0) p = b[c];
			} while (c != 0);
			Common.WriteLn();  Common.WriteLn();
			ReportFixed();
		} // ReportDetails 

		public static void ReportFixed()	// Generate output of all fixed elements
		// uses n, s, and b[] as input
		{
			string Ss;						// String "s" or "" if s = 1
			string Sis;						// String "are" or "is" if s = 1 }
			if (s == 1)						// Setup is or are
			{
				Ss = ""; Sis = "is";
			}
			else
			{
				Ss = "s"; Sis = "are";
			}
			Common.WriteLn("The fixed element" + Ss + " in this Josephus permutation " + Sis + ":");
			for (i = 1; i <= n; i++)
			{
				if (b[i] == i)					// Output fixed elements
					Common.Write(i + " ");
				Common.MuInterrupt();
				if (Common.abortCalc)
				{
					Common.WriteLn();
					Common.WriteLn2("Manually aborted before report finished");
					return;
				}
			}
			if (s == 0) Common.Write("None!");
			Common.WriteLn();
			Common.WriteLn();
		} // ReportFixed 

		public static void ReportResults()	// Generate normal output
		// uses n, f, m, s, maxS, b[], and x[] as input
		{
			GenerateFixed();
			int nx = 0;						// Number of saves fixed elements
			string Ss;						// String "s" or "" if s = 1
			string Sis;						// String "are" or "is" if s = 1 }
			if (s == 1)						// Setup is or are
			{
				Ss = ""; Sis = "is";
			}
			else
			{
				Ss = "s"; Sis = "are";
			}
			Common.DoubleSpace();
			Common.Write("n = " + n + ",  f = " + f);
			if (f > n) Common.Write(" => " + (1 + (f - 1) % n));
			Common.Write(",  m = " + m);
			Common.WriteLn(":  Object " + b[n] + " was selected last!");
			Common.Write("There " + Sis + " " + s + " fixed element" + Ss);
			if (s > 0)
			{
				nx = s;
				if (nx > maxS) nx = maxS;
				Common.Write(":  ");
				for (i = 1; i <= nx; i++)
				{
					Common.Write("" + x[i]);
					if (i != nx) Common.Write(", ");
				}
			}
			if (s > nx) Common.Write(", ... ");
			Common.WriteLn(".");  Common.WriteLn();
		} // ReportResults

		public static void GenerateFixed()	// Generate array of first fixed elements
		// uses n, maxS, and b[] as input
		// computes x[]
		{
			int sl = 0;						// number of fixed elements found
			for (i = 1; i <= n; i++)
			{
				if (b[i] == i)
				{
					sl++;
					if (sl <= maxS)
						x[sl] = i;	// Save up to maxS fixed elements
					else
						return;
				}
			}
		} //GenerateFixed 

		private void timerPlot_Tick(object sender, System.EventArgs e)
			// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Common.plotUp = false;
				Dispose(true);
				return;
			}
		}

		private void buttonExit_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void TestExit(KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				Common.plotUp = false;
				Dispose(true);
			}
		}

		private void buttonNumberN_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonFirstF_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonAbout_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonPlot_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonSkipM_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void PlotControlXY_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonNm_Click(object sender, EventArgs e)
		{
			if (n > 1 && !Common.running)
			{
				textBoxNumberN.Text = (n - 1).ToString();
				buttonNumberN_Click();
				buttonPlot_Click();
			}
		}

		private void buttonNp_Click(object sender, EventArgs e)
		{
			if (n < maxN && !Common.running)
			{
				textBoxNumberN.Text = (n + 1).ToString();
				buttonNumberN_Click();
				buttonPlot_Click();
			}
		}

		private void buttonFm_Click(object sender, EventArgs e)
		{
			if (f > 1 && !Common.running)
			{
				textBoxFirstF.Text = (f - 1).ToString();
				buttonFirstF_Click();
				buttonPlot_Click();
			}
		}

		private void buttonFp_Click(object sender, EventArgs e)
		{
			if (f < maxN && !Common.running)
			{
				textBoxFirstF.Text = (f + 1).ToString();
				buttonFirstF_Click();
				buttonPlot_Click();
			}
		}

		private void buttonMm_Click(object sender, EventArgs e)
		{
			if (m > 1 && !Common.running)
			{
				textBoxSkipM.Text = (m - 1).ToString();
				buttonSkipM_Click();
				buttonPlot_Click();
			}
		}

		private void buttonMp_Click(object sender, EventArgs e)
		{
			if (m < maxN && !Common.running)
			{
				textBoxSkipM.Text = (m + 1).ToString();
				buttonSkipM_Click();
				buttonPlot_Click();
			}
		}

		private void PlotForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		// exit Plot form
		{
			Common.plotUp = false;
			Common.abortCalc = true;
		}

		public static int[] a;	// Working array of objects
								// Ends up with a[i] = when object i was selected
		public static int[] b;	// Record of objects selected
								// Ends up with b[i] = object # selected on k'th selection
		public static int c;	// Index to current object being scanned
		public static int f;	// # of first object to be selected
		public static int fP;	// previous f
		public static int i;	// Utility index
		public static int k;	// Number of objects selected (killed) so far
		public static int m;	// m for selecting every m'th object 
		public static int mP;	// previous m
		public static int n;	// The total number of objects in the circle to start with
		public static int nP;	// previous n
		public static int p;	// Index to previous object
		public static int r;	// Remaining number of objects in the circle
		public static int s;	// Number of fixed (stationary) elements in permutation
		public static int maxN;	// The maximum total number of objects in the circle 
		public static int maxP;	// The maximum n in a plot, first ManP points
		public static int maxS;	// Up to maxS saved fixed elements
		public static int[] x;	// Saved fixed elements
	}
}

