using System;
using System.IO;
using System.Windows.Forms; // for Application

namespace MyNamespace
{
	/// <summary>
	///		Run form for JosephusCS program
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class RunForm : Form
	{
		private Button buttonAbortCalc;
		private Button buttonClearLogFile;
		private Button buttonClearOutput;
		private Button buttonConfiguration;
		private Button buttonLog;
		private Button buttonQuit;
		private Button buttonReport;
		private Button buttonReportAll;
		private Button buttonStatusOfCalc;
		private Label labelCtrlF9;
		private Label labelEsc;
		private Label labelF11;
		private Label labelF12;
		private Label labelF2;
		private Label labelF5;
		private Label labelF6;
		private Label labelF7;
		private Label labelF8;
		private Label labelF9;
		private Label labelRunning;
		private MainMenu mainMenuRun;
		private MenuItem menuItemAbout;
		private MenuItem menuItemExit;
		private MenuItem menuItemFile;
		private MenuItem menuItemHelp;
		private MenuItem menuItemHelpForm;
		private RichTextBox richTextOut;
		private System.ComponentModel.IContainer components;
		private Timer timerRun;
		public Button buttonPlot;

		public RunForm()
		{
			InitializeComponent();

			Global.runTextOut = richTextOut;
			Global.runTextOut.Clear();
			Global.objRunForm = this;
			this.Width = runWidth;			// Resize the form
			this.Height = runHeight;
			this.CenterToScreen();
			Common.timeIt = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RunForm));
			this.buttonAbortCalc = new Button();
			this.buttonClearLogFile = new Button();
			this.buttonClearOutput = new Button();
			this.buttonConfiguration = new Button();
			this.buttonLog = new Button();
			this.buttonPlot = new Button();
			this.buttonQuit = new Button();
			this.buttonReport = new Button();
			this.buttonReportAll = new Button();
			this.labelCtrlF9 = new Label();
			this.labelEsc = new Label();
			this.labelF11 = new Label();
			this.labelF12 = new Label();
			this.labelF2 = new Label();
			this.labelF7 = new Label();
			this.labelF8 = new Label();
			this.labelF9 = new Label();
			this.labelRunning = new Label();
			this.mainMenuRun = new MainMenu(this.components);
			this.menuItemFile = new MenuItem();
			this.menuItemExit = new MenuItem();
			this.menuItemHelp = new MenuItem();
			this.menuItemHelpForm = new MenuItem();
			this.menuItemAbout = new MenuItem();
			this.richTextOut = new RichTextBox();
			this.timerRun = new Timer(this.components);
			this.buttonStatusOfCalc = new Button();
			this.labelF6 = new Label();
			this.labelF5 = new Label();
			this.SuspendLayout();
			// 
			// buttonAbortCalc
			// 
			this.buttonAbortCalc.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonAbortCalc.Location = new System.Drawing.Point(16, 48);
			this.buttonAbortCalc.Name = "buttonAbortCalc";
			this.buttonAbortCalc.Size = new System.Drawing.Size(88, 23);
			this.buttonAbortCalc.TabIndex = 5;
			this.buttonAbortCalc.Text = "Abort Calc.";
			this.buttonAbortCalc.Click += new System.EventHandler(this.buttonAbortCalc_Click);
			this.buttonAbortCalc.KeyDown += new KeyEventHandler(this.buttonAbortCalc_KeyDown);
			// 
			// buttonClearLogFile
			// 
			this.buttonClearLogFile.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonClearLogFile.Location = new System.Drawing.Point(16, 8);
			this.buttonClearLogFile.Name = "buttonClearLogFile";
			this.buttonClearLogFile.Size = new System.Drawing.Size(88, 23);
			this.buttonClearLogFile.TabIndex = 1;
			this.buttonClearLogFile.Text = "Clear Log File";
			this.buttonClearLogFile.Click += new System.EventHandler(this.buttonClearLogFile_Click);
			this.buttonClearLogFile.KeyDown += new KeyEventHandler(this.buttonClearLogFile_KeyDown);
			// 
			// buttonClearOutput
			// 
			this.buttonClearOutput.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonClearOutput.Location = new System.Drawing.Point(432, 8);
			this.buttonClearOutput.Name = "buttonClearOutput";
			this.buttonClearOutput.Size = new System.Drawing.Size(88, 23);
			this.buttonClearOutput.TabIndex = 4;
			this.buttonClearOutput.Text = "Clear Output";
			this.buttonClearOutput.Click += new System.EventHandler(this.buttonClearOutput_Click);
			this.buttonClearOutput.KeyDown += new KeyEventHandler(this.buttonClearOutput_KeyDown);
			// 
			// buttonConfiguration
			// 
			this.buttonConfiguration.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonConfiguration.Location = new System.Drawing.Point(224, 48);
			this.buttonConfiguration.Name = "buttonConfiguration";
			this.buttonConfiguration.Size = new System.Drawing.Size(88, 23);
			this.buttonConfiguration.TabIndex = 6;
			this.buttonConfiguration.Text = "Configuration";
			this.buttonConfiguration.Click += new System.EventHandler(this.buttonConfiguration_Click);
			this.buttonConfiguration.KeyDown += new KeyEventHandler(this.buttonConfiguration_KeyDown);
			// 
			// buttonLog
			// 
			this.buttonLog.Cursor = Cursors.Arrow;
			this.buttonLog.Font = new System.Drawing.Font("Tahoma", 7.75F, System.Drawing.FontStyle.Bold);
			this.buttonLog.Location = new System.Drawing.Point(120, 8);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 23);
			this.buttonLog.TabIndex = 2;
			this.buttonLog.Text = "Logging Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			this.buttonLog.KeyDown += new KeyEventHandler(this.buttonLog_KeyDown);
			// 
			// buttonPlot
			// 
			this.buttonPlot.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonPlot.Location = new System.Drawing.Point(536, 48);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.Size = new System.Drawing.Size(48, 23);
			this.buttonPlot.TabIndex = 9;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			this.buttonPlot.KeyDown += new KeyEventHandler(this.buttonPlot_KeyDown);
			// 
			// buttonQuit
			// 
			this.buttonQuit.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonQuit.Location = new System.Drawing.Point(600, 48);
			this.buttonQuit.Name = "buttonQuit";
			this.buttonQuit.Size = new System.Drawing.Size(48, 23);
			this.buttonQuit.TabIndex = 10;
			this.buttonQuit.Text = "Quit";
			this.buttonQuit.Click += new System.EventHandler(this.buttonQuit_Click);
			this.buttonQuit.KeyDown += new KeyEventHandler(this.buttonQuit_KeyDown);
			// 
			// buttonReport
			// 
			this.buttonReport.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonReport.Location = new System.Drawing.Point(329, 48);
			this.buttonReport.Name = "buttonReport";
			this.buttonReport.Size = new System.Drawing.Size(88, 23);
			this.buttonReport.TabIndex = 35;
			this.buttonReport.Text = "Report";
			this.buttonReport.Click += new System.EventHandler(this.buttonReport_Click);
			this.buttonReport.KeyDown += new KeyEventHandler(this.buttonReport_KeyDown);
			// 
			// buttonReportAll
			// 
			this.buttonReportAll.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonReportAll.Location = new System.Drawing.Point(432, 48);
			this.buttonReportAll.Name = "buttonReportAll";
			this.buttonReportAll.Size = new System.Drawing.Size(88, 23);
			this.buttonReportAll.TabIndex = 8;
			this.buttonReportAll.Text = "Report All";
			this.buttonReportAll.Click += new System.EventHandler(this.buttonReportAll_Click);
			this.buttonReportAll.KeyDown += new KeyEventHandler(this.buttonReportAll_KeyDown);
			// 
			// labelCtrlF9
			// 
			this.labelCtrlF9.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlF9.Location = new System.Drawing.Point(40, 32);
			this.labelCtrlF9.Name = "labelCtrlF9";
			this.labelCtrlF9.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlF9.TabIndex = 26;
			this.labelCtrlF9.Text = "Ctrl+F9";
			// 
			// labelEsc
			// 
			this.labelEsc.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelEsc.Location = new System.Drawing.Point(48, 72);
			this.labelEsc.Name = "labelEsc";
			this.labelEsc.Size = new System.Drawing.Size(24, 16);
			this.labelEsc.TabIndex = 34;
			this.labelEsc.Text = "Esc";
			// 
			// labelF11
			// 
			this.labelF11.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF11.Location = new System.Drawing.Point(464, 32);
			this.labelF11.Name = "labelF11";
			this.labelF11.Size = new System.Drawing.Size(24, 16);
			this.labelF11.TabIndex = 25;
			this.labelF11.Text = "F11";
			// 
			// labelF12
			// 
			this.labelF12.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF12.Location = new System.Drawing.Point(552, 72);
			this.labelF12.Name = "labelF12";
			this.labelF12.Size = new System.Drawing.Size(24, 16);
			this.labelF12.TabIndex = 30;
			this.labelF12.Text = "F12";
			// 
			// labelF2
			// 
			this.labelF2.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF2.Location = new System.Drawing.Point(616, 72);
			this.labelF2.Name = "labelF2";
			this.labelF2.Size = new System.Drawing.Size(24, 16);
			this.labelF2.TabIndex = 28;
			this.labelF2.Text = "F2";
			// 
			// labelF7
			// 
			this.labelF7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF7.Location = new System.Drawing.Point(362, 72);
			this.labelF7.Name = "labelF7";
			this.labelF7.Size = new System.Drawing.Size(24, 16);
			this.labelF7.TabIndex = 36;
			this.labelF7.Text = "F7";
			// 
			// labelF8
			// 
			this.labelF8.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF8.Location = new System.Drawing.Point(464, 72);
			this.labelF8.Name = "labelF8";
			this.labelF8.Size = new System.Drawing.Size(24, 16);
			this.labelF8.TabIndex = 27;
			this.labelF8.Text = "F8";
			// 
			// labelF9
			// 
			this.labelF9.Font = new System.Drawing.Font("Tahoma", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF9.Location = new System.Drawing.Point(152, 32);
			this.labelF9.Name = "labelF9";
			this.labelF9.Size = new System.Drawing.Size(24, 16);
			this.labelF9.TabIndex = 17;
			this.labelF9.Text = "F9";
			// 
			// labelRunning
			// 
			this.labelRunning.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelRunning.Location = new System.Drawing.Point(222, 11);
			this.labelRunning.Name = "labelRunning";
			this.labelRunning.Size = new System.Drawing.Size(93, 16);
			this.labelRunning.TabIndex = 37;
			this.labelRunning.Text = "**Running**";
			// 
			// mainMenuRun
			// 
			this.mainMenuRun.MenuItems.AddRange(new MenuItem[] {
			this.menuItemFile,
			this.menuItemHelp});
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new MenuItem[] {
			this.menuItemExit});
			this.menuItemFile.Text = " &File ";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 0;
			this.menuItemExit.Text = "E&xit";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 1;
			this.menuItemHelp.MenuItems.AddRange(new MenuItem[] {
			this.menuItemHelpForm,
			this.menuItemAbout});
			this.menuItemHelp.Text = " &Help F1 ";
			// 
			// menuItemHelpForm
			// 
			this.menuItemHelpForm.Index = 0;
			this.menuItemHelpForm.Text = "&Help Form        F1";
			this.menuItemHelpForm.Click += new System.EventHandler(this.menuItemHelpForm_Click);
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Index = 1;
			this.menuItemAbout.Text = "&About...";
			this.menuItemAbout.Click += new System.EventHandler(this.menuItemAbout_Click);
			// 
			// richTextOut
			// 
			this.richTextOut.Cursor = Cursors.Arrow;
			this.richTextOut.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextOut.Location = new System.Drawing.Point(0, 88);
			this.richTextOut.Name = "richTextOut";
			this.richTextOut.ReadOnly = true;
			this.richTextOut.ScrollBars = RichTextBoxScrollBars.ForcedVertical;
			this.richTextOut.Size = new System.Drawing.Size(664, 440);
			this.richTextOut.TabIndex = 13;
			this.richTextOut.Text = "";
			this.richTextOut.KeyDown += new KeyEventHandler(this.richTextOut_KeyDown);
			// 
			// timerRun
			// 
			this.timerRun.Enabled = true;
			this.timerRun.Interval = 1000;
			this.timerRun.Tick += new System.EventHandler(this.timerRun_Tick);
			// 
			// buttonStatusOfCalc
			// 
			this.buttonStatusOfCalc.Font = new System.Drawing.Font("Tahoma", 6.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonStatusOfCalc.Location = new System.Drawing.Point(120, 48);
			this.buttonStatusOfCalc.Name = "buttonStatusOfCalc";
			this.buttonStatusOfCalc.Size = new System.Drawing.Size(88, 23);
			this.buttonStatusOfCalc.TabIndex = 38;
			this.buttonStatusOfCalc.Text = "Status of Calc.";
			this.buttonStatusOfCalc.Click += new System.EventHandler(this.buttonStatusOfCalc_Click);
			this.buttonStatusOfCalc.KeyDown += new KeyEventHandler(this.buttonStatusOfCalc_KeyDown);
			// 
			// labelF6
			// 
			this.labelF6.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF6.Location = new System.Drawing.Point(256, 72);
			this.labelF6.Name = "labelF6";
			this.labelF6.Size = new System.Drawing.Size(24, 16);
			this.labelF6.TabIndex = 20;
			this.labelF6.Text = "F6";
			// 
			// labelF5
			// 
			this.labelF5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF5.Location = new System.Drawing.Point(152, 72);
			this.labelF5.Name = "labelF5";
			this.labelF5.Size = new System.Drawing.Size(24, 16);
			this.labelF5.TabIndex = 39;
			this.labelF5.Text = "F5";
			// 
			// RunForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 529);
			this.Controls.Add(this.labelF5);
			this.Controls.Add(this.buttonStatusOfCalc);
			this.Controls.Add(this.buttonAbortCalc);
			this.Controls.Add(this.buttonClearLogFile);
			this.Controls.Add(this.buttonClearOutput);
			this.Controls.Add(this.buttonConfiguration);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.buttonQuit);
			this.Controls.Add(this.buttonReport);
			this.Controls.Add(this.buttonReportAll);
			this.Controls.Add(this.labelCtrlF9);
			this.Controls.Add(this.labelEsc);
			this.Controls.Add(this.labelF11);
			this.Controls.Add(this.labelF12);
			this.Controls.Add(this.labelF2);
			this.Controls.Add(this.labelF6);
			this.Controls.Add(this.labelF7);
			this.Controls.Add(this.labelF8);
			this.Controls.Add(this.labelF9);
			this.Controls.Add(this.labelRunning);
			this.Controls.Add(this.richTextOut);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuRun;
			this.Name = "RunForm";
			this.StartPosition = FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Run";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.Resize += new System.EventHandler(this.RunForm_Resize);
			this.ResumeLayout(false);

		}
		#endregion

		public void Run(int iMaxN, int iNumberN, int iFirstF, int iSkipM, int iMaxP, StartupForm callerForm)
		// -------- Begin Main program Run for input and output to control calculations
		{
			if (Global.runFormUp) { Dispose(true); return; }
			Common.SetPriority(-1);		// lower priority to BelowNormal
			tQuitFlag = true;
			Global.runFormUp = true;
			Common.plotUp = false;
			Global.programURL = "http://www.geocities.com/hjsmithh/Josephus/index.html";
			this.Show();
			this.Text = Global.title + " - Run";
			objStartupForm = callerForm;
			new Common();	// initialize class Common
			SetRunning();
			new JosephusCS(iMaxN, iNumberN, iFirstF, iSkipM, iMaxP);	// initialize class JosephusCS
			if (Common.homeDir == null) Common.homeDir = Environment.CurrentDirectory.ToString();
			if (Common.selectPath == null) Common.selectPath = Common.homeDir;
			if (Common.selectFile == null) Common.selectFile = "";
			if (Common.selectFilter == 0) Common.selectFilter = 1;
			Common.outS = Global.runTextOut;
			Common.runCmdLog = buttonLog;
			Global.runTextOut.Clear();
			ClearOutput();
			SetNotRunning();
			Common.DoubleSpace();
			buttonPlot.Focus();
		} // Run

		public void SetRunning()
		{
			labelRunning.Text = "**Running**";
			Common.running = true;
		}

		public void SetNotRunning()
		{
			labelRunning.Text = "";
			Common.running = false;
		}

		private void buttonReportAll_Click(object sender, System.EventArgs e)
		{
			if (Common.running) return;
			SetRunning();
			Common.abortCalc = false;
			buttonAbortCalc.Focus();
			PlotForm.Orbits();
			if (!Common.abortCalc)
			{
				PlotForm.ReportDetails();
				Common.abortCalc = false;
				PlotForm.ReportResults();
			}
			Common.abortCalc = false;
			SetNotRunning();
			FocusBothUs();
		}

		private void buttonReport_Click(object sender, System.EventArgs e)
		{
			if (Common.running) return;
			SetRunning();
			Common.abortCalc = false;
			buttonAbortCalc.Focus();
			PlotForm.Orbits();
			if (!Common.abortCalc)
			{
				PlotForm.ReportResults();
			}
			Common.abortCalc = false;
			SetNotRunning();
			FocusBothUs();
		}

		public static void FocusBothUs() // focus on Run output text boxes
		{
			Global.runTextOut.Select(Global.runTextOut.Text.Length, 0); // move to bottom/end of output text box
			Global.runTextOut.Focus();
		}

		public static void ClearOutput() // clear Output Screen
		{
			DateTimePicker dateTime = new DateTimePicker();
			string dateTimeString = dateTime.Value.ToString();
			Common.DoubleSpace(); // double space for the possible benefit of the log file
			Global.runTextOut.Text = "";
			Common.WriteLn2("Output Screen: Cleared " + dateTimeString);
			Common.WriteLn(Global.runTextOut, null, Global.title + ", " + Global.version);
			if (Global.system != "") Common.WriteLn("Run on: " + Global.system);
			Common.WriteLn();
		}

		public static void HelpForm() // bring up the Help form
		{
			if (Global.helpUp < 3)			// allow at most 3 Help Forms up
			{
				HelpForm objHelpForm = new HelpForm();
				objHelpForm.Show();
				objHelpForm.Help();			// call sub Help in the Help Form
			}
		}

		private void buttonClearLogFile_Click(object sender, System.EventArgs e)
		// clear and initialize the log file
		{
			Common.ClearLog();
			SetLogCaption();
			FocusBothUs();
		}

		private void buttonClearOutput_Click(object sender, System.EventArgs e)
		// clear the output text box
		{
			ClearOutput();
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle the log screen to log file option
		{
			Common.ToggleLogg();
			FocusBothUs();
		}

		private void buttonQuit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			tQuitFlag = false;
			this.Close();		// memberFormClosing will do the work
		}

		private void buttonConfiguration_Click(object sender, System.EventArgs e)
		// bring up the configuration form
		{
			if (Common.configUp) return;
			ConfigForm objConfigForm = new ConfigForm();
			objConfigForm.Show();
			objConfigForm.Config();		// call sub Config in the Config Form
		}

		private void menuItemAbout_Click(object sender, System.EventArgs e)
		// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			tQuitFlag = true;
			this.Close();		// memberFormClosing will do the work
		}

		private void menuItemHelpForm_Click(object sender, System.EventArgs e)
		// display the Help form
		{
			Common.DoubleSpace();
			HelpForm();
		}

		public void SetLogCaption() // set log command button Caption
		{
			if (Common.logg)
			{
				if (buttonLog.Text != "Logging Is On")
					buttonLog.Text  = "Logging Is On";
			}
			else
			{
				if (buttonLog.Text != "Logging Is Off")
					buttonLog.Text  = "Logging Is Off";
			}
		}

		private void timerRun_Tick(object sender, System.EventArgs e)
		// don't hog the processor, but don't slowdown too much
		{
			if (Common.running)
			{
				buttonReport.Enabled = false;
				buttonReportAll.Enabled = false;
				buttonPlot.Enabled = false;
			}
			else
			{
				buttonReport.Enabled = true;
				buttonReportAll.Enabled = true;
				buttonPlot.Enabled = true;
			}
			Application.DoEvents();	// process user requested actions;
		}

		private void FunctionKeys(object sender, KeyEventArgs e)
		// process requests from Function keys
		{
			if (e.KeyCode == Keys.F1)			// display the Help form
			{
				HelpForm();
			}
			else if (e.KeyCode == Keys.F2)		// quit program OR restart
			{
				tQuitFlag = false;
				this.Close();					// memberFormClosing will do the work
			}
			else if (e.KeyCode == Keys.F5)		// get Status of calculation
			{
				buttonStatusOfCalc_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F6)		// display Configuration form
			{
				buttonConfiguration_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F7)		// Report
			{
				buttonReport_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F8)		// Report ALL
			{
				buttonReportAll_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F9)		// toggle Logging OR clear Log file
			{
				if(Control.ModifierKeys != Keys.Control)
				{
					buttonLog_Click(sender, e);	// F9 toggle Logging to Log file on/off
				}
				else
				{
					buttonClearLogFile_Click(sender, e);	// Ctrl+F9 clear Log file
				}
			}
			else if (e.KeyCode == Keys.F11)		// clear output TextBox
			{
				buttonClearOutput_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F12)		// bring up the plot form
			{
				buttonPlot_Click(sender, e);
			}
			else if (e.KeyCode == Keys.Escape)	// interrupt/Abort a long calculation
			{
				buttonAbortCalc_Click(sender, e);
			}
		}

		private void richTextOut_KeyDown(object sender, KeyEventArgs e)
		// function keys for output TextBox same as Run Form
		{
			FunctionKeys(sender, e);
		}

		private void RunForm_Resize(object sender, System.EventArgs e) // resize the run form
		{
			int jTop = buttonQuit.Top + buttonQuit.Height + 18;
			this.richTextOut.SetBounds(1, jTop, this.ClientRectangle.Width - 2, this.ClientRectangle.Height - jTop - 1);
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		// the Run form is being closed so quit the Run form and go to Startup form
		// with .exe file, Close button click while running giver "Illegal operation"
		// so I put in a running test and a cancel
		{
			if (Common.running)
			{
				Common.abortCalc = true;
				Common.WriteDLn2("When **Running**, select Quit twice to quit");
				e.Cancel = true; // cancel the Unload request
				return;
			}
			if (Common.logg)
			{
				DateTimePicker dateTime = new DateTimePicker();
				string dateTimeString = dateTime.Value.ToString();
				Common.WriteLn("Log file " + Common.logFile + " Closed " + dateTimeString);
				Common.WriteLn(null, Common.outL);
				Common.outL.Close();
				Common.logg = false;
			}
			this.Hide();
			Global.runFormUp = false;
			if (tQuitFlag)
			{
				Dispose(true);
				objStartupForm.TotalQuit();
			}
			else
				objStartupForm.Show();
		}

		private void buttonPlot_Click(object sender, System.EventArgs e)
		// bring up the plot form
		{
			if (Common.running) return;
			if (Common.plotUp) return;
			PlotForm objPlotForm = new PlotForm();
			objPlotForm.Show();
			objPlotForm.Plot();		// call sub Plot in the Plot Form
		}

		private bool tQuitFlag;				// total quit/exit flag
		// tQuitFlag helps implement the requirement that a close or menuItemExit will totally quit the
		// program while a Quit will go to the Startup form
		private StartupForm objStartupForm;

		public static int helpHeight = 520;		// current height of the Help Form in pixels
		public static int helpWidth = 698;		// current width of the Help Form in pixels
		public static int runHeight = 564;		// current height of the Run Form in pixels
		public static int runWidth = 682;		// current width of the Run Form in pixels

		private static double NextDb(ref string st)
			// get next double from string
		{
			st = st.TrimStart(' ');		// delete leading blanks
			int p = st.IndexOf(' ');	// find next blank
			if (p < 0) p = st.Length;
			string s = st.Substring(0, p);
			st = st.Remove(0, p);
			try { return Convert.ToDouble(s); }
			catch { return 0.0; }
		}

		private void buttonAbortCalc_Click(object sender, System.EventArgs e)
		{
			if (Common.abortCalc) return;
			Common.abortCalc = true;
		}

		private void buttonClearLogFile_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonLog_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonShowData_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonClearOutput_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonAbortCalc_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonConfiguration_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonLoad_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonReportAll_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonPlot_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonQuit_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonReport_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}

		private void buttonStatusOfCalc_Click(object sender, EventArgs e)
		// request the status of the running calculation
		{
			if (Common.running)
			{
				Common.statReq = true;
			}
			FocusBothUs(); // catch all
		}

		private void buttonStatusOfCalc_KeyDown(object sender, KeyEventArgs e)
		{
			FunctionKeys(sender, e);		
		}
	}
}
